Subject: Weird TCP hang when doing loopback NFS (wireshark traces attached)

From: Trond Myklebust <trond.myklebust-7I+n7zu2hftEKMMhf/[email-masked]>
Date: Sun, 01 Mar 2015 14:14:51 -0500

Hi,

When doing testing of NFSv3 loopback mounts (client and server are on
the same IP address), I'm seeing a very reproducible hang in which the
client stops receiving data from the server. The TCP connection is still
marked as established, and the server appears to continue to receive and
send data, however the client does not.

So far, I've reproduced on both v4.0-rc1, and the Fedora v3.18.7 kernel.

The reproducer is simply to loopback mount using NFSv3, and then run the
'fsx' filesystem exerciser. I'm usually able to trigger the hang with
"fsx -N 100000 foobar".

I've attached a couple of wireshark trace of a few frames just before
and during the hang in case it jogs any memories.

Cheers
  Trond